#pragma once

#include "backend.h"

#include <QUrl>
#include <QWebSocket>

class ExLlama: public AiBackend
{
	Q_OBJECT
private:
	QWebSocket m_webSocket;

	void socketMessage(const QString& message);

	static const QString actionToStr(Request::type_t type);
	static Request::type_t strToAction(const QString& str);

protected:
	virtual bool generateImpl(const Request& request) override;

public:
	ExLlama();
	virtual bool ready() override;
	virtual void open(const QUrl& url) override;
	virtual QString backendName() override;
	static QString backendNameStatic();

	virtual ~ExLlama();

};
